﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace SPDigg
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();

            GetDiggData();
        }

        public void GetDiggData()
        {
            // Stolen from 'The Gu'
            string url = "http://services.digg.com/stories/topic/programming?count=20&appkey=http%3A%2F%2Fscottgu.com";
            WebClient wc = new WebClient();
            wc.DownloadStringCompleted += new DownloadStringCompletedEventHandler(wc_DownloadStringCompleted);
            wc.DownloadStringAsync(new Uri(url));               

        }

        void wc_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if(e.Error == null) //w00t, no explosions!
            {
                DisplayStories(e.Result);
            }
        }

        void DisplayStories(string xml)
        {
            XDocument xmlStories = XDocument.Parse(xml);

            var stories = from story in xmlStories.Descendants("story")
                          select new DiggStory
                                     {
                                         Id = (int) story.Attribute("id"),
                                         Title = ((string) story.Element("title")).Trim(),
                                         NumDiggs = (int) story.Attribute("diggs"),
                                     };
            DiggStories.SelectedIndex = -1;
            DiggStories.ItemsSource = stories;
        }
    }
}
