﻿
function create-ddfHeader
{
	#DDF Header -- BEGIN
	$script:ddfFile = ".OPTION EXPLICIT 
	.Set CabinetNameTemplate=$script:ddfSolutionName.wsp
	.Set Cabinet=on
	.Set Compress=on
	.Set DiskDirectoryTemplate=CDROM ; All cabinets go in single directory
	.Set CompressionType=MSZIP ; All files compressed in cabinet files
	.Set UniqueFiles=""ON""
	.Set MaxDiskSize=CDROM
	.Set DiskDirectory1=$script:ddfSolutionDirectory\$script:ddfSolutionName

	"
	#DDF Header -- END
}

function recurse-directoryStructure($directoryPath)
{
	#Write-Host "Checking: " $directoryPath
	ls "$directoryPath\*" -exclude *.wsp,*.inf,*.rpt|%{
		if(!$_.PSIsContainer){
			if($_.Directory.Name.ToLower() -eq "bins")
				{ add-fileToDDFWithLocation $_.FullName "" $_.Name}
			else
				{ add-fileToDDF($_.FullName)}
				#{ add-fileToDDFWithLocation $_.FullName "" $_.Name}
				#
		}
		else{ recurse-directoryStructure($_.FullName) }
	}
}

function add-fileToDDF([string]$fileLocation)
{
	$localFileLocation = $fileLocation.Substring($script:ddfSolutionDirectory.Length)
	$cabFileLocation = $fileLocation.Substring($script:ddfSolutionDirectory.Length + $script:ddfSolutionName.Length + 1)
	#$ddfLine = """{0}"" ""{1}"" {2}" -f $localFileLocation,$cabFileLocation,[system.environment]::newline
	$ddfLine = """{0}"" ""{1}"" {2}" -f $fileLocation,$cabFileLocation,[system.environment]::newline
	Write-Host "Adding: " $localFileLocation
	$script:ddfFile += $ddfLine
}
function add-fileToDDFWithLocation([string]$fileLocation,[string]$cabBaseLocation,[string]$fileName)
{
	$localFileLocation = $fileLocation.Substring($solutionDirectory.Length)
	$cabFileLocation = $cabBaseLocation + $fileName
	$ddfLine = """{0}"" ""{1}"" {2}" -f $fileLocation,$cabFileLocation,[system.environment]::newline
	Write-Host "Adding: " $localFileLocation
	$script:ddfFile += $ddfLine
}



function create-ddf([string]$directoryLocation)
{
	$folder = get-item $directoryLocation
	write-host $folder.FullName
	create-ddfFromFolder($folder)
	
}

function create-ddfFromFolder([System.IO.DirectoryInfo]$folder)
{
	# Name of the directory that contains the solution
	#$solutionName = "JustAddCode.PowerShellFeatures" 
	$script:ddfSolutionName = $folder.Name

	# Directory above the solution (where the DDF file is stored)
	$script:ddfSolutionDirectory = $folder.Parent.FullName + "\"
	# Output DDF Filename
	$outName = "$script:ddfSolutionName.ddf"

	write-host "Creating DDF"
	create-ddfHeader
	recurse-directoryStructure($folder.FullName)
	$script:ddfFile | out-file -filePath ($script:ddfSolutionDirectory + $outName) -encoding UTF8
}


function copy-requiredAssemblies([System.IO.DirectoryInfo]$folder)
{
	# Reads the manifest to determine which DLLs should be copied in, and then copies them
	[xml]$manifest = cat ($folder.FullName+"\manifest.xml")
	rm ($folder.FullName + "\bins\*")
	$manifest.solution.assemblies.assembly | %{
		$sourceFile = $folder.Parent.Parent.FullName + "\bin\debug\" + $_.Location
		$destFile = $folder.FullName + "\bins\" + $_.Location
		cp $sourceFile $destFile
	}

}


 