﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

namespace SPSilverlight.SharePoint
{
    public class SLWebPart : WebPart
    {
        #region Properties
        private string _XAPFile;
        [Browsable(true), Personalizable(), WebBrowsable, Category("Custom Settings"),
                DefaultValue("Page"), Description("XAP File")]
        public string XAPFile
        {
            get { return _XAPFile; }
            set { _XAPFile = value; }
        }

        public IDictionary<string,string> InitInformation = new Dictionary<string, string>();
        #endregion

        #region Boring Stuff
        private string CreateControlHTML(string controlLocation,IDictionary<string,string> parameters)
        {
            string html =
                @"<object data=""data:application/x-silverlight,"" type=""application/x-silverlight-2"" width=""550"" height=""300"">
			    <param name=""source"" value=""{0}""/>
			    <param name=""background"" value=""transparent"" />
			    <param name=""windowless"" value=""true"" />
			    <param name=""initParams""
				value=""{1}"" />
    			<param name=""minRuntimeVersion"" value=""2.0.31005.0"" />
    			<param name=""autoUpgrade"" value=""true"" />
			   	<a href=""http://go.microsoft.com/fwlink/?LinkID=124807"" style=""text-decoration: none;"">
     			    <img src=""../SilverlightAssets-old/images/NoSilverlight.jpg"" alt=""Get Microsoft Silverlight"" style=""border-style: none""/>
			    </a>
		    </object>";
            html = string.Format(html, controlLocation, CreateParametersString(parameters));
            return html;
        }

        
        #endregion


        protected override void CreateChildControls()
        {
            base.CreateChildControls();
           
            Literal l = new Literal();
            l.Text = CreateControlHTML(XAPFile, InitInformation);
            Controls.Add(l);
            
        }


        #region SecretStuff
        private string CreateParametersString(IDictionary<string,string> parameters)
        {
            string parms = string.Empty;
            foreach (var s in parameters)
            {
                string parameter = string.Format("{0}={1}", s.Key, s.Value);
                if (parms.Length > 0)
                    parms += ",";
                parms += parameter;
            }
            return parms;
        }
        #endregion
    }
}
