﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Visifire.Charts;

namespace SPSilverlight
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
            CreateChart();

        }


        /// <summary>
        /// Function to create a chart
        /// </summary>
        public void CreateChart()
        {
            // Create a new instance of Chart
            Chart chart = new Chart();

            // Set the chart width and height
            chart.Width = 400;
            chart.Height = 300;

            // Create a new instance of Title
            Title title = new Title();

            // Set title property
            title.Text = "MNSPCamp is now";

            // Add title to Titles collection
            chart.Titles.Add(title);

            // Create a new instance of DataSeries
            DataSeries dataSeries = new DataSeries();

            // Set DataSeries property
            dataSeries.RenderAs = RenderAs.Column;

            // Create a DataPoint
            DataPoint dataPoint1 = new DataPoint();
            dataPoint1.YValue = rand.Next(10, 100);
            dataSeries.DataPoints.Add(dataPoint1);
            DataPoint dataPoint2 = new DataPoint();
            dataPoint2.YValue = rand.Next(10, 100);
            dataSeries.DataPoints.Add(dataPoint2);
            DataPoint dataPoint3 = new DataPoint();
            dataPoint3.YValue = rand.Next(10, 100);
            dataSeries.DataPoints.Add(dataPoint3);
            DataPoint dataPoint4 = new DataPoint();
            //dataPoint4.YValue = rand.Next(10, 100);

            if(App.Current.Resources.Contains("ChartValue"))
            {
                string stringVal = App.Current.Resources["ChartValue"] as string;
                Double chartValue = Double.Parse(stringVal);
                dataPoint4.YValue = chartValue;
            }
            else
            {
                dataPoint4.YValue = rand.Next(10, 100);
            }


            dataSeries.DataPoints.Add(dataPoint4);


            // Add dataSeries to Series collection.
            chart.Series.Add(dataSeries);

            // Add chart to LayoutRoot
            LayoutRoot.Children.Clear();
            LayoutRoot.Children.Add(chart);
        }

        /// <summary>
        /// Create a random class variable
        /// </summary>
        Random rand = new Random(DateTime.Now.Millisecond);
    }
}
