﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;
using Visifire.Charts;

namespace SPTwitter
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
            CreateChart();
        }


        /// <summary>
        /// Function to create a chart
        /// </summary>
        public void CreateChart()
        {
            // Create a new instance of Chart
            Chart chart = new Chart();

            // Set the chart width and height
            chart.Width = 500;
            chart.Height = 300;

            // Create a new instance of Title
            Title title = new Title();

            // Set title property
            title.Text = "Visifire Sample Chart";

            // Add title to Titles collection
            chart.Titles.Add(title);

            // Create a new instance of DataSeries
            DataSeries dataSeries = new DataSeries();

            // Set DataSeries property
            dataSeries.RenderAs = RenderAs.Column;

            // Create a DataPoint
            DataPoint neilPoint = new DataPoint();
            neilPoint.YValue = GetData("romangeeko");
            neilPoint.AxisXLabel = "romangeeko";
            dataSeries.DataPoints.Add(neilPoint);
            
            DataPoint spcPoint = new DataPoint();
            spcPoint.YValue = GetData("mnspcamp");
            spcPoint.AxisXLabel = "mnspcamp";
            dataSeries.DataPoints.Add(spcPoint);



            

            // Add dataSeries to Series collection.
            chart.Series.Add(dataSeries);

            // Add chart to LayoutRoot
            LayoutRoot.Children.Add(chart);
        }

        private int GetData(string controlId)
        {
            try
            {
                string result =
                    System.Windows.Browser.HtmlPage.Window.Eval("document.getElementById('" + controlId + "').innerHTML;") as string;
                string xml = System.Windows.Browser.HttpUtility.HtmlDecode(result);
                //MessageBox.Show(xml);
                XDocument doc = XDocument.Parse(xml);
                XNamespace atomNS = "http://www.w3.org/2005/Atom";
                var stories = from story in doc.Descendants(atomNS + "entry")
                              select new Tweet
                              {
                                  //Id = (string)story.Element("id"),
                                  Title = (string)story.Element("title"),
                              };
                return stories.Count();
            }
            catch(Exception)
            {}
            return 0;
        }


    }
}
